/*
 * libADLMIDI is a free Software MIDI synthesizer library with OPL3 emulation
 *
 * Original ADLMIDI code: Copyright (c) 2010-2018 Joel Yliluoma <bisqwit@iki.fi>
 * libADLMIDI and related utils: Copyright (c) 2015-2018 Vitaly Novichkov <admin@wohlnet.ru>
 *
 * Library is based on the ADLMIDI, a MIDI player for Linux and Windows with OPL3 emulation:
 * http://iki.fi/bisqwit/source/adlmidi.html
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ADLMIDI_HPP
#define ADLMIDI_HPP

#include "adlmidi.h"

struct ADL_MIDIPlayer;

class ADLMIDI_DECLSPEC AdlInstrumentTester
{
    struct Impl;
    Impl *P;

public:
    explicit AdlInstrumentTester(ADL_MIDIPlayer *device);
    virtual ~AdlInstrumentTester();

    // Find list of adlib instruments that supposedly implement this GM
    void FindAdlList();
    void Touch(unsigned c, unsigned volume);
    void DoNote(int note);
    void NextGM(int offset);
    void NextAdl(int offset);
    bool HandleInputChar(char ch);

private:
    AdlInstrumentTester(const AdlInstrumentTester &);
    AdlInstrumentTester &operator=(const AdlInstrumentTester &);
};

#endif //ADLMIDI_HPP

